SystemOrganization addCategory: #'NOCompletion-View'!
SystemOrganization addCategory: #'NOCompletion-Model'!

NECSelectorEntry subclass: #NOCDatedEntry
	instanceVariableNames: 'date next previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCDatedEntry methodsFor: 'operations' stamp: 'rr 2/21/2009 11:49'!
<= anEntry
	^ date = anEntry date 
		ifTrue: [contents <= anEntry contents]
		ifFalse: [date > anEntry date]! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'rr 2/21/2009 11:49'!
date
	^ date! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'rr 4/9/2009 15:38'!
date: d
	date := d! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:12'!
link: anODatedEntry
	"Link the given entry after me."

	anODatedEntry
		next: next;
		previous: self.
	next previous: anODatedEntry.
	next := anODatedEntry! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:38'!
matches: pref

	^contents beginsWithEmpty: pref caseSensitive: false! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:07'!
next

	^next! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:08'!
next: anODatedEntry

	next := anODatedEntry! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'rr 4/9/2009 15:32'!
now
	date := DateAndTime now! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:07'!
previous

	^previous! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:08'!
previous: anODatedEntry

	previous := anODatedEntry! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:08'!
unlink

	next previous: previous.
	previous next: next! !

NECMenuMorph subclass: #NOCMenuMorph
	instanceVariableNames: 'lastActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-View'!

!NOCMenuMorph methodsFor: 'accessing' stamp: 'rr 4/15/2009 15:32'!
height
	^ 7! !

!NOCMenuMorph methodsFor: 'actions' stamp: 'rr 6/26/2009 11:33'!
narrowCompletion
	| model |
	
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	model notEmpty ifTrue: [self selected: 1].
	model entries size < self selected ifTrue: [self selected: model entries size].
	self show.
	^ true! !

NECController subclass: #NOCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCController class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 4/12/2012 13:25'!
initialize 
	super initialize.
	self register.! !

!NOCController methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
contextClass
	^NOCContext! !

!NOCController methodsFor: 'private' stamp: 'CamilloBruni 8/5/2012 23:16'!
menuMorphClass
	^ NOCMenuMorph! !

NECUntypedModel subclass: #NOCModel
	instanceVariableNames: 'table expand context nextModel cachedEntries classTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 11:29'!
addEntry: ent
	(self tableForEntry: ent) addEntry: ent ! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:56'!
addSelectors
	! !

!NOCModel methodsFor: 'accessing' stamp: 'damiencassou 7/27/2009 14:22'!
at: aNumber
	
	^ self entries at: (aNumber max: 1) ! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 14:17'!
completionAt: aNumber
	| entry |
	"when an entry is selected, update its date (for inlined messages which do not appear in the method's body"
	entry := (self at: aNumber) completion.
	self addEntry: entry.
	^ entry separateKeywords, ' '.! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/5/2012 23:55'!
context: aNOCContext
	context := aNOCContext.! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/5/2012 23:33'!
contract
	expand := true.
	nextModel := nil.! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/5/2012 23:35'!
entries
	| ent more |
	entries ifEmpty: [ self loadEntries ].
	^  entries! !

!NOCModel methodsFor: 'accessing' stamp: 'RomainRobbes 8/2/2010 17:56'!
entryCount
	^ self entries size! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/15/2009 13:28'!
expand
	expand := true.! !

!NOCModel methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/3/2012 21:26'!
initialize
	super initialize.
	self contract.
	table := NOCCompletionTable default.
	classTable := NOCCompletionTable classes.! !

!NOCModel methodsFor: 'initialize-release' stamp: 'rr 4/14/2009 13:56'!
initializeSelectors! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 12:25'!
loadEntries
	| priorityEntries  |
	"entries used from the last recently used"
	priorityEntries := 6.
	self loadNextModelEntries.
	
	entries size <= priorityEntries
		ifTrue: [ ^ self ].
		
	"most recently used entries first!!"
	self sortByLastRecentlyUsed: self loadFavoredEntries.
		
	"sort the rest alphabetically"
	entries 
		mergeSortFrom: priorityEntries
		to: entries size 
		by: [ :a :b| 
			(a contents asString compare: b contents asString caseSensitive: false) <= 2 ]! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 11:50'!
loadFavoredEntries
	
	(narrowString notEmpty and: [narrowString first isUppercase]) 
			ifTrue: [ ^ classTable entriesMatching: narrowString ].
					
	includeSelectors 
		ifTrue: [ ^ table entriesMatching: narrowString ]
		ifFalse: [ ^ #() ].! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 11:51'!
loadNextModelEntries
	entries := self nextModel entries ! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/4/2012 00:52'!
narrowWith: aString
	self narrowString: aString.
	self loadEntries.
	self nextModel ifNotNilDo: [:nm | nm narrowWith: aString].! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/6/2012 12:58'!
nextModel
	^ nextModel ifNil: [
		nextModel := context nextModel. 
		nextModel narrowWith: narrowString.
		nextModel ].! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
noNextModel
	nextModel := NOCEmptyModel new.! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2012 21:28'!
resetEntries
	super resetEntries.! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 12:32'!
sortByLastRecentlyUsed: lastRecentlyUsedEntries
	"Sort my entrys by the most recently used date"
	| lastRecentlyUsed |
	
	lastRecentlyUsed := Dictionary new.
	
	lastRecentlyUsedEntries do: [ :entry|
		lastRecentlyUsed at: entry contents put: entry date asSeconds ].
	
	entries sort: [ :a :b|| dateA dateB|
		dateA := lastRecentlyUsed at: a contents asString ifAbsent: [ 0 ].
		dateB := lastRecentlyUsed at: b contents asString ifAbsent: [ 0 ].
		dateA >= dateB].! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:46'!
table
	^ table! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2012 21:26'!
tableForEntry: ent
	^ (ent notEmpty and: [ent first isUppercase]) 
			ifTrue: [classTable]
			ifFalse: [table]! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/6/2012 00:01'!
title
	^ self nextModel title! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
useUniqueTable
	table := NOCCompletionTable new entriesPerPrefix: 20.
	! !

NECContext subclass: #NOCContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCContext methodsFor: 'model creation' stamp: 'CamilloBruni 8/5/2012 23:55'!
createModel
	| aModel |
	
	aModel := NOCModel
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors.
	aModel
		context: self.
		
	^ aModel ! !

!NOCContext methodsFor: 'model creation' stamp: 'CamilloBruni 8/5/2012 23:58'!
nextModel 
	"Provide a next lookup model"
	^ super createModel! !

Object subclass: #LogForImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!LogForImplementor commentStamp: 'StephaneDucasse 2/26/2012 22:48' prior: 0!
I added the methods that were different (mainly in class extensions) of NECcompltation. That way we can compare.

Here are the notes resulting from the comparison of the two approaches

* ecompletion override TextMorph>>keyStroke: 

* OCompletion uses the ToolSet

ECToolSet>>codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	| completionAllowed editor stringHolder |
	
	editor := aTextMorph editor.
	stringHolder := editor ifNotNil: [editor model].

	completionAllowed := NECPreferences enabled and:[ NECController allowModel: stringHolder ].
	completionAllowed
		ifTrue: [(stringHolder completionController handleKeystrokeBefore: evt editor: editor)
				ifTrue: [^ self]].
	aBlock value.
	"sends to keyStroke event handler, if any"
	"Narrow the completion with any of the keys"
	completionAllowed
		ifTrue: [stringHolder completionController handleKeystrokeAfter: evt editor: editor]
		
SmalltalkEditor>>codeCompletionAround:  aBlock textMorph:  aTextMorph keyStroke: anEvent
	"I'm a editor for Smalltalk, so, ok do completion around"
	Smalltalk tools codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: anEvent
	
		
TextMorph>>keyStroke: evt
	"Handle a keystroke event."
	self resetBlinkCursor. "don't blink during type-in"
	self editor 
		codeCompletionAround: [| action |
			evt keyValue = 13 ifTrue:["CR - check for special action"
				action := self crAction.
				action ifNotNil:[
					"Note: Code below assumes that this was some
					input field reacting on CR. Break the keyboard
					focus so that the receiver can be safely deleted."
					evt hand newKeyboardFocus: nil.
					^ action value]].
			self handleInteraction: [editor keystroke: evt].
			self updateFromParagraph.
			super keyStroke: evt  "sends to keyStroke event handler, if any"]
		textMorph: self 
		keyStroke: evt
		
ToolRegistry>>codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	^(self hasToolNamed: #codeCompletion)
	ifTrue: [ self codeCompletion codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt ]
	ifFalse: [ aBlock value ]
		





* how to handle extension
so far OCompletion is doing

StringHolder|Workspace>>createCompletionController
	
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECController ])
			model: self
	
* Then we should add something to FlatMessageListBrowser and this is not nice.
	
* we shoul unify the settings
in ECompletion the ugly squeakish preferences

useECompletionInsteadOfOCompletion

	<preference: 'Use eCompletion instead of OCompletion'
		category: 'OCompletion'
		description: 'Decide if you want to use eCompletion in newly opened tools instead of OCompletion.'
		type: #Boolean>
	^useECompletionInsteadOfOCompletion ifNil: [ false ]


in OCompletion

settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #'OCompletion: Code Completion') 
		target: self; 
		parentName: #codeBrowsing;
		selector: #enabled;
		icon: UITheme current smallConfigurationIcon;
		description: 'Enable or disable code completion in browsers, debuggers and workspaces.';
		with: [
			(aBuilder setting: #caseSensitive) 
				label: 'Case Sensitive';
		 		description: 'Decide if you want OCompletion to be case sensitive or not.'.
			(aBuilder setting: #smartCharacters) 
				label: 'Smart Characters';
		 		description: 'Decide if you want OCompletion to use smart characters, e.g, to automatically close brackets.'.
			(aBuilder setting: #matchSubStrings)
				label: 'Match SubStrings';
				description: 'Decide if you want OCompletion to perform subString searches, which can be slower, rather than only front-matching selectors.'.
			(aBuilder setting: #useECompletionInsteadOfOCompletion)
				label: 'Use eCompletion instead of OCompletion';
				description: 'Decide if you want to use eCompletion in newly opened tools instead of OCompletion.' ]
	





* Open question why 
StringHolder>>completionController
	| controller | 
	controller := self triggerEvent: #getCompletionController.
	controller ifNil:[ controller := self initializeCompletionController ].
	^controller
	
Trigger an event and the initialize

StringHolder>>initializeCompletionController
	| controller |
	controller := self createCompletionController.
	self 
		when: #getCompletionController
		evaluate: (MessageSend 
				receiver: controller
				selector: #yourself).
	^ controller
	
possible answer because this is to avoid adding an instance variable? But I do not understand since it could also just return the instance.
!

Object subclass: #NOCCompletionTable
	instanceVariableNames: 'table numberofEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

NOCCompletionTable class
	instanceVariableNames: 'classTable table'!

NOCCompletionTable class
	instanceVariableNames: 'classTable table'!

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/4/2012 01:05'!
classes
	^ classTable ifNil: [classTable := self new entriesPerPrefix: 40]! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/14/2009 17:13'!
default
	^ table ifNil: [table := self new entriesPerPrefix: 40]! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 8/3/2012 14:08'!
initialize
	SystemAnnouncer uniqueInstance 
		unsubscribe: self;
		on: MethodAdded, MethodModified 
			send: #methodChanged: 
			to: self.
	self initializeTable.! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/28/2009 10:18'!
initializeTable
	self initializeWithInlinedMessages.
	self initializeWithPackages.
	self initializeWithRecentChanges.! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/28/2009 09:54'!
initializeWithInlinedMessages
	#(ifTrue: ifFalse: whileTrue: whileFalse: ifNil: ifNotNil: to:do: at:put: next: next size atEnd class value value: do: new: new) 
		do: [:e | self default addEntry: e].! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/15/2011 12:40'!
initializeWithPackages
	| pkgs |
	pkgs :=  'Kernel* Collection*'.
	pkgs ifNotNil: [
	(pkgs findTokens: ' ' ) do: [:e |  self default quickFillWithCategoriesMatching: e ]]

! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
initializeWithRecentChanges
	NOCRecentChanges new readRecentChanges fillCompletionTable.! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 06:23'!
lookForOB
	(Smalltalk at: #OBTextPanel ifAbsent: [^self]) compile: 'createCompletionController
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECController ])
			model: self'! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/3/2012 14:44'!
methodChanged: event
	self default totalNumberOfEntries < 200 ifTrue: [self default quickFillWithCategoryOf: event methodClass].
	self default totalNumberOfEntries < 500 ifTrue: [self default quickFillWithClass: event methodClass].
	self default justCompiled: event selector in: event methodClass.! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:55'!
addEntry: aString 
	| d |
	d := DateAndTime now.
	self 
		addEntry: aString
		date: d! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 10:52'!
addEntry: aString date: d 
	| lists |
	lists := self listsForPrefix: aString.
	lists do: [:e | e
		addEntry: aString
		date: d] ! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 06:35'!
compiled: selector in: class date: date

	| method |
	self addEntry: selector date: date.
	self class classes addEntry: class theNonMetaClass name date: date.
	(class canUnderstand: selector) ifFalse: [ ^self ].
	method := class compiledMethodAt: selector ifAbsent: [ ^self ].
	method messages do: [ :m | self  addEntry: m date: date ].
	method literals do: [ :each |
		(each isVariableBinding and: [
			each key notNil and: [
				each key first isUppercase ] ])
					ifTrue: [ 
						self class classes addEntry: each key date: date ] ]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:14'!
entriesMatching: prefix
	| list |
	
	list := self listForPrefix: prefix.
	^ list entriesMatching: prefix! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:42'!
entriesPerPrefix: n
	numberofEntries := n! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/10/2009 12:11'!
fillRate
	^ self totalNumberOfEntries / self maxNumberOfEntries ! !

!NOCCompletionTable methodsFor: 'initialize-release' stamp: 'rr 4/9/2009 17:45'!
initialize
	table := Dictionary new.! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:01'!
justCompiled: selector in: class 
	| date |
	date := DateAndTime now.
	self 
		compiled: selector
		in: class
		date: date! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
listForPrefix: aString 
	| prefix |
	aString isEmpty ifTrue: [^ NOCEntryList ofSize: numberofEntries].
	prefix := aString size = 1 
			ifTrue: [ aString first asLowercase asString] 
			ifFalse: [(aString first: 2) collect: [:e | e asLowercase]].
			
	^ table 
		at: prefix
		ifAbsentPut: [ NOCEntryList ofSize: numberofEntries ]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
listsForPrefix: aString 
	|  prefixes |
	aString isEmpty ifTrue: [^ Array with: (NOCEntryList ofSize: numberofEntries)].
	prefixes := OrderedCollection with: aString first asLowercase asString.
	 
	aString size > 1 
			ifTrue: [prefixes add: ((aString first: 2) collect: [:e | e asLowercase])].
	^ prefixes collect: [:prefix | table 
		at: prefix
		ifAbsentPut: [ NOCEntryList ofSize: numberofEntries ]]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/10/2009 12:10'!
maxNumberOfEntries
	^ 26 * 26 * numberofEntries ! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:46'!
numberOfEntries
	^ numberofEntries! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 7/15/2012 13:48'!
quickFillWithCategoriesMatching: pattern
	(Smalltalk organization categoriesMatching: pattern) do: [:category | 
		(Smalltalk organization classesInCategory: category) do: [:e | self quickFillWithClass: e]]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 7/15/2012 13:47'!
quickFillWithCategoryOf: cls
	(Smalltalk organization classesInCategory: cls theNonMetaClass category) do: [:e | self quickFillWithClass: e]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 14:10'!
quickFillWithClass: cls
	cls methodsDo: [:e | self justCompiled: e selector in: cls]
	! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/10/2009 11:21'!
reset
	table := Dictionary new.! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:49'!
totalNumberOfEntries
	^ table inject: 0 into: [:total :list | total + list numEntries]! !

Object subclass: #NOCEmptyModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 16:47'!
entries
	^ Array new! !

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:27'!
entryCount 
	^ 0! !

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:26'!
narrowString: string! !

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:26'!
narrowWith: string 
! !

Object subclass: #NOCEntryList
	instanceVariableNames: 'size entries entryHead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCEntryList class methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:44'!
ofSize: n 
	^ self new setSize: n; yourself! !

!NOCEntryList methodsFor: 'adding' stamp: 'rr 4/9/2009 16:06'!
addEntry: aSymbol
	self addEntry: aSymbol date: DateAndTime now! !

!NOCEntryList methodsFor: 'adding' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
addEntry: aSymbol date: aDate

	| entry currentEntry |
	entry := entries at: aSymbol ifAbsent: nil.
	entry 
		ifNotNil: [ entry unlink ]
		ifNil: [ 
			entry := NOCDatedEntry contents: aSymbol type: #selector.
			entries at: aSymbol put: entry ].
	entry date: aDate.
	currentEntry := entryHead previous.
	[ currentEntry == entryHead or: [
		currentEntry date <= aDate ] ] whileFalse: [
			currentEntry := currentEntry previous ].
	currentEntry link: entry.
	entries size > size ifTrue: [
		entry := entryHead next unlink.
		entries removeKey: entry contents ]! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/29/2010 18:56'!
entriesMatching: prefix
	
	^Array new: entries size // 4 + 1 streamContents: [ :stream |
		| entry |
		entry := self firstEntry.
		[ entry == entryHead ] whileFalse: [
			(entry matches: prefix) ifTrue: [ stream nextPut: entry ].
			entry := entry previous ] ]! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
first
	^self firstEntry contents! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
firstEntry
	^ entryHead previous! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
last
	^self lastEntry contents! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
lastEntry
	^ entryHead next! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 2/21/2009 11:46'!
numEntries
	^ entries size! !

!NOCEntryList methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
setSize: n
	size := n.
	entries := Dictionary new: n.
	entryHead := NOCDatedEntry contents: #'' size type: #selector.
	entryHead
		next: entryHead;
		previous: entryHead.
	
	! !

Object subclass: #NOCRecentChanges
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCRecentChanges methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
fillCompletionTable
	records do: [:e | self fillCompletionTable: NOCCompletionTable default withRecord: e]! !

!NOCRecentChanges methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:05'!
fillCompletionTable: table withRecord: r
	r methodClass ifNotNilDo: [:cls |
		table compiled: r methodSelector in: cls date: r timeStamp]! !

!NOCRecentChanges methodsFor: 'as yet unclassified' stamp: 'ul 10/29/2010 01:57'!
readRecentChanges
	| changeFile end changeList |
	changeFile := (SourceFiles at: 2) readOnlyCopy setConverterForCode.
	end := changeFile size.
	changeList := Cursor read showWhile: [
		ChangeList new
			scanFile: changeFile
			from: (0 max: end - 50000)
			to: end ].
	records := changeList changeList select: [:e | e type = #method].
	! !
NOCCompletionTable initialize!
NOCController initialize!
